#include <tc/tc.h>
#include "epm_handler_common.h"
#include <vector>
#include <iostream>
#include "CRUL_server_call_httpserver.h"
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include "common_itk_util.h"
#include <tc/preferences.h>
#include "string_utils.h"
#include <fclasses\tc_date.h>
#include "ocilib.h"
#include "cJSON.h"
void connectSql() {
	int url_num = 0;
	char** url_vals = NULL;
	PREF_ask_char_values("database_tc", &url_num, &url_vals);
	string url = url_vals[0];
	url.append("/").append(url_vals[2]);
	printf("url ==> %s \n", url.c_str());
	if (ConnServer(url_vals[3], url_vals[4], (char*)url.c_str()) == -1)
	{
		printf("ʾ:мݱʧ\n");
	}
}
void closeConn() {
	DisConnServer();
}

cJSON* getDrawingInform(tag_t changeTag) {
	int changeNo,signNo, placesNo,beforeNo,verBefNo,aftNo,aftVerNo,reasonNo,processTypeNo;
	char **changeDrawingNos, **signs, **placesNos, **changeBefs, **versionBefs,
		 **changeAfts, **versionAfts, **changeReasons, **processTypes;
	AOM_ask_value_strings(changeTag, "zt2_ChangeDrawingNo",&changeNo, &changeDrawingNos);
	AOM_ask_value_strings(changeTag, "zt2_Sign", &signNo, &signs);
	AOM_ask_value_strings(changeTag, "zt2_PlacesNo", &placesNo, &placesNos);
	AOM_ask_value_strings(changeTag, "zt2_ChangeBefore1", &beforeNo, &changeBefs);
	AOM_ask_value_strings(changeTag, "zt2_SZVersionbefore", &verBefNo, &versionBefs);
	AOM_ask_value_strings(changeTag, "zt2_ChangeAfter1", &aftNo, &changeAfts);
	AOM_ask_value_strings(changeTag, "zt2_SZRevisedversion", &aftVerNo, &versionAfts);
	AOM_ask_value_strings(changeTag, "zt2_ChangeReason", &reasonNo, &changeReasons);
	AOM_ask_value_strings(changeTag, "zt2_ProcessType1", &processTypeNo, &processTypes);
	cJSON* infomations = cJSON_CreateArray();
	for (int i = 0; i < changeNo; i++) {
		cJSON* infomation = cJSON_CreateObject();
		cJSON_AddStringToObject(infomation, "S_DrawingCode", changeDrawingNos[i]);
		cJSON_AddStringToObject(infomation, "S_Sign", signNo > i ? signs[i] : "");
		cJSON_AddStringToObject(infomation, "S_CS", placesNo > i ? placesNos[i] : "");
		cJSON_AddStringToObject(infomation, "S_PreChange", beforeNo > i ? changeBefs[i] : "");
		cJSON_AddStringToObject(infomation, "S_PreChangeVersion", verBefNo > i ? versionBefs[i] : "");
		cJSON_AddStringToObject(infomation, "S_AfterChange", aftNo > i ? changeAfts[i] : "");
		cJSON_AddStringToObject(infomation, "S_AfterChangeVersion", aftVerNo > i ? versionAfts[i] : "");
		cJSON_AddStringToObject(infomation, "S_ChangeReason", reasonNo > i ? changeReasons[i] : "");
		cJSON_AddStringToObject(infomation, "S_ZZPCL", processTypeNo > i ? processTypes[i] : "");
		cJSON_AddItemToArray(infomations, infomation);
	}
	return infomations;
}
 

//͵OA
int CHINT_task_complete(EPM_action_message_t msg) {

	int ifail = ITK_ok;
	ECHO("=========================================================\n");
	ECHO("CHINT_task_complete ʼִ\n");
	ECHO("=========================================================\n");
	tag_t root_task = NULLTAG, *sub_tasks = NULL, current_task = NULLTAG, type_tag = NULLTAG;
	int sub_task_count = 0, occur_of_counts = 0;
	tag_t* taskAttches = NULLTAG;
	tag_t cur_task = NULLTAG;
	char* jobName;
	current_task = msg.task;
	AOM_ask_value_string(current_task, "job_name", &jobName);
	EPM_ask_root_task(msg.task, &root_task);
	EPM_ask_sub_tasks(root_task, &sub_task_count, &sub_tasks);
	EPM_ask_attachments(root_task, EPM_target_attachment, &occur_of_counts, &taskAttches);
	//ȡurlַ
	char* url;
	PREF_ask_char_value("CHINT_ECNSendOAUrl", 0, &url);
	//ȡǰĿ
	connectSql();
	for (int count = 0; count < occur_of_counts; count++) {
		char *type;
		tag_t taskTag = taskAttches[count];
		AOM_ask_value_string(taskTag, "object_type", &type);
		if (strcmp(type, "ZT2_Change") == 0) {
			//ȡ ѯݿдJSON
			char* changeType,*productModel,
				*productName, *fileName, *contractNo, *contractName, 
				*changeDateStr, *changeUnit;
			date_t changeDate;
			AOM_ask_value_string(taskTag, "zt2_ChangeType", &changeType);//
			AOM_ask_value_string(taskTag, "zt2_ProductModel", &productModel);//Ʒͺ
			AOM_ask_value_string(taskTag, "zt2_ProductName", &productName); // Ʒ
			AOM_ask_value_string(taskTag, "zt2_FileName", &fileName); // 	ļż
			AOM_ask_value_string(taskTag, "zt2_ContractNo", &contractNo); // ͬ
			AOM_ask_value_string(taskTag, "zt2_ContractName", &contractName); // ͬ
			AOM_ask_value_date(taskTag, "zt2_ChangeDate", &changeDate); // ʵʩ
			AOM_ask_value_string(taskTag, "zt2_ChangeUnit1", &changeUnit); // ͬ
			cJSON* paramValue = cJSON_CreateObject();
			//jsonֶ
			cJSON_AddStringToObject(paramValue, "S_ChangeTypes", changeType);
			cJSON_AddStringToObject(paramValue, "S_ProductNumber", productModel);
			cJSON_AddStringToObject(paramValue, "S_ProductName", productName);
			cJSON_AddStringToObject(paramValue, "S_Pcodename", fileName);
			cJSON_AddStringToObject(paramValue, "S_Contractcode", contractNo);
			cJSON_AddStringToObject(paramValue, "S_ContractName", contractName);
			DATE_date_to_string(changeDate, "%Y-%m-%d", &changeDateStr);
			cJSON_AddStringToObject(paramValue, "T_MaterialDate", changeDateStr);
			cJSON_AddStringToObject(paramValue, "S_FFBM", changeUnit);
			//EH_DrawingInformationͼϢ
			cJSON* infomations = getDrawingInform(taskTag);
			cJSON_AddItemToObject(paramValue, "EH_DrawingInformation", infomations);

		}
	
	}
	closeConn();
	//

	return ifail;
}