#include "CRUL_server_call_httpserver.h"
#include <map>
#include <string>
#include <sstream>
#include <iostream>
//#define HTTP_HOST "localhost"
//#define HTTP_POST 9293
//#include <boost/property_tree/ptree.hpp>
//#include <boost/property_tree/json_parser.hpp>
size_t write_data(void* ptr, size_t size, size_t nmemb, void* stream) {
	string data((const char*)ptr, (size_t)size * nmemb);
	*((stringstream*)stream) << data << endl;
	return size * nmemb;
}
//string callHttpserver(string signinfoJsonString,string url)
//{
//	CURL* curl;
//	CURLcode res;
//	curl = curl_easy_init();
//	printf("͵ַ%s\n", url);
//	std::stringstream out;
//	if (curl) {
//		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
//		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
//		//curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
//		//curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
//		struct curl_slist* headers = NULL;
//		headers = curl_slist_append(headers, "Accept-Charset: UTF-8");
//		headers = curl_slist_append(headers, "Content-Type: application/json;charset=UTF-8");
//		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
//		// ýݵĴʹű
//		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
//		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
//		printf("ݣ%s\n", signinfoJsonString.c_str());
//		//printf("data=>%s\n",signinfoJsonString.c_str());
//		const char* data = signinfoJsonString.c_str();
//		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
//		curl_easy_setopt(curl, CURLOPT_CONNECTTIMEOUT, 10);
//		curl_easy_setopt(curl, CURLOPT_TIMEOUT, 20);
//		res = curl_easy_perform(curl);
//
//		if (res != 0) {
//			string errMessage = curl_easy_strerror(res);
//		}
//
//		printf("ֵ%d\n", res);
//	}
//	string str_json = out.str();
//	curl_easy_cleanup(curl);
//	printf("str_json===>%s\n", str_json.c_str());
//	return str_json;
//}
string callHttpserver(string signinfoJsonString, string url){
	CURL *curl;
	CURLcode res;
	curl = curl_easy_init();
	std::stringstream out;
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		struct curl_slist *headers = NULL;
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		headers = curl_slist_append(headers, "Content-Type: application/json");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		const char *data = signinfoJsonString.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		if (res != 0) {
			string errMessage = curl_easy_strerror(res);
		}
		printf("ֵ%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("str_json===>%s\n", str_json.c_str());
	return str_json;
}

string sendOA() {
	CURL *curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, "https://bpmtest10.chint.com/Portal/Webservices/BPMExtendService.asmx/SetItemValues");
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist *headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		const char *data = "sfId=111177777&instanceId=3333&entityParamValues=ddd";
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
}
string callHttpGet(string url) {
	void* curl = curl_easy_init();
	// URL
	std::stringstream out;
	curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
	curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
	// ýݵĴʹű
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);

	// ִHTTP GET
	CURLcode res = curl_easy_perform(curl);
	if (res != CURLE_OK) {
		fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
	}

	// ݴoutУ֮
	//cout << out.str() << endl;
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("str_json===>%s\n", str_json.c_str());
	return str_json;
}
string sendOA(string sfid, string instanceId, string entityParamValues, string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, false);
		string temp;
		temp.append("sfId=").append(sfid).append("&instanceId=").append(instanceId).append("&entityParamValues=").append(entityParamValues);
		printf("temp=%s\n", temp.c_str());
		const char* data = temp.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		//curl_easy_strerror
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
	return str_json;
}
/*֪ͨOA
*/
string ecnSendOA(string instanceId, string entityParamValues, string url) {
	CURL* curl;
	CURLcode res;
	std::stringstream out;
	curl = curl_easy_init();
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
		curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
		curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &out);
		struct curl_slist* headers = NULL;
		headers = curl_slist_append(headers, "Content-Type: application/x-www-form-urlencoded");
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, false);
		string temp;
		temp.append("workflowCode=EH_TE_ChangeNotice").append("&userCode=").
			append(instanceId).append("&finishStart=true").append("&entityParamValues=").append(entityParamValues);
		printf("temp=%s\n", temp.c_str());
		const char* data = temp.c_str();
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
		res = curl_easy_perform(curl);
		//curl_easy_strerror
		printf("temp=%d\n", res);
	}
	string str_json = out.str();
	curl_easy_cleanup(curl);
	printf("return Msg===>%s\n", str_json.c_str());
	return str_json;
}
//void callHttpserverDwgtopdf(string signinfoJsonString, char* HTTP_HOST)
//{
//	CURL* curl;
//	CURLcode res;
//	char httpUrl[1028] = "\0";
//	curl = curl_easy_init();
//	sprintf(httpUrl, "http://%s:%d/server/dwgtopdf", HTTP_HOST, HTTP_POST);
//	if (curl) {
//		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
//		curl_easy_setopt(curl, CURLOPT_URL, httpUrl);
//		//curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
//		//curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
//		struct curl_slist* headers = NULL;
//		headers = curl_slist_append(headers, "Accept-Charset: GBK");
//		headers = curl_slist_append(headers, "Content-Type: application/json;charset=GBK");
//		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
//		WriteLog("ݣ%s\n", signinfoJsonString.c_str());
////		printf("data=>%s\n", signinfoJsonString.c_str());
//		const char* data = signinfoJsonString.c_str();
//		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
//		curl_easy_setopt(curl, CURLOPT_CONNECTTIMEOUT, 10);
//		curl_easy_setopt(curl, CURLOPT_TIMEOUT, 20);
//		res = curl_easy_perform(curl);
//		WriteLog("ֵ%d\n", res);
//		
//	}
//	curl_easy_cleanup(curl);
//}
//
//void callHttpserverMail(string signinfoJsonString, char* HTTP_HOST)
//{
//	CURL* curl;
//	CURLcode res;
//	char httpUrl[4096] = "\0";
//	WriteLog("ݳ%d\n", signinfoJsonString.size());
//	curl = curl_easy_init();
//	sprintf(httpUrl, "http://%s:%d/server/sendmail", HTTP_HOST, HTTP_POST);
////	printf("call=>%s \n", httpUrl);
//	WriteLog("͵·%s\n", httpUrl);
//	if (curl) {
//		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
//		curl_easy_setopt(curl, CURLOPT_URL, httpUrl);
//		//curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L);
//		//curl_easy_setopt(curl, CURLOPT_DEFAULT_PROTOCOL, "https");
//		struct curl_slist* headers = NULL;
//		headers = curl_slist_append(headers, "Accept-Charset: GBK");
//		headers = curl_slist_append(headers, "Content-Type: application/json;charset=GBK");
//		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
////		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, "Expect:");
//		WriteLog("ݣ%s\n", signinfoJsonString.c_str());
//	//	printf("data=>%s\n", signinfoJsonString.c_str());
//		const char* data = signinfoJsonString.c_str();
//		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
//		curl_easy_setopt(curl, CURLOPT_CONNECTTIMEOUT, 10);
//		curl_easy_setopt(curl, CURLOPT_TIMEOUT, 20);
//		res = curl_easy_perform(curl);
//		WriteLog("ֵ%d\n", res);
//	}
//	curl_easy_cleanup(curl);
//}