
#ifndef EPM_HANDLER_COMMON
#define EPM_HANDLER_COMMON

#include <epm/epm.h>
#include <string>
#include <map>


#ifdef __cplusplus
extern "C" {
#endif


	using namespace std;

	#define ERROR_QRY_NOT_FOUND (EMH_USER_error_base + 120)
#define TC_specification	"IMAN_specification"
int WX_Check_Property(EPM_rule_message_t msg);
int Modify_Attributes(EPM_rule_message_t msg);
int Check_range(EPM_rule_message_t msg);
int chint_getChgOrde(EPM_action_message_t msg);
int chint_getProduct(EPM_action_message_t msg);
int Remove_Release_Status(EPM_action_message_t msg);
int AddTime(EPM_action_message_t msg);
int AddReleaseStatus(EPM_action_message_t msg);
int AutomaticRelease(EPM_action_message_t msg);
int hasFillInChechList(EPM_action_message_t msg);
// int chintP(EPM_action_message_t msg);
int chintProperty(EPM_action_message_t msg);
int chint_signoff_dataset(EPM_action_message_t msg);
int chint_DesignProcess(EPM_action_message_t msg);
int chintSignChange(EPM_action_message_t msg);
int DbomToEMethod(void *returnValue);
int DbomToEMethodUser(void *returnValue);
int CloneTempProcess(void *returnValue);
int EbomToPMethod(void *returnValue);
int HXC_create_item_post(METHOD_message_t* msg , va_list va);//
int AutoFeeding(void *returnValue);
int chint_pdf_signoff(EPM_action_message_t msg);
int chint_updateToPi(EPM_action_message_t msg);
int chint_add_to_workflow(EPM_action_message_t msg);
int chint_backCheckTable(EPM_action_message_t msg);
int chint_remove_other_deisgndata(EPM_action_message_t msg);
int chint_CheckTable_State(EPM_action_message_t msg); 
int chint_check_ZC_ZJ_BOM(EPM_action_message_t msg);
int chint_check_exist_ebom(EPM_action_message_t msg);
int UpdateWorkTime(void *returnValue);
int CHINT_task_complete(EPM_action_message_t msg);
int CHINT_cossheet_upgrade(EPM_action_message_t msg);
int CHINT_SendOAMaterial(EPM_action_message_t msg);
int CHINT_GetFrock(EPM_action_message_t msg);
	//user service end
#ifdef __cplusplus
}
#endif

#endif 

#define ITKCALL( argument )                                             \
{                                                                       \
	int retcode = argument;                                             \
	if ( retcode != ITK_ok ) {                                          \
	char* s;                                                        \
	printf( " "#argument "\n" );                                    \
	printf( "  returns [%d]\n", retcode );                          \
	EMH_ask_error_text (retcode, &s);                               \
	TC_printf( "  Teamcenter ERROR: [%s]\n", s);           \
	printf( "  in file ["__FILE__"], line [%d]\n\n", __LINE__ );    \
	if (s != 0) MEM_free (s);                                       \
	}                                                                   \
}